Mon May 13 22:38:16 1996  Ian Searle  <ians@demitasse>

	* matop2.c (matrix_ReadGeneric): Handle empty files.

Fri Apr  5 10:08:03 1996  Ian Searle  <ians@demitasse>

	* symbol.c (tmp_pop): change logic to zero out each element in
	tmpstack as it is poped, so that we don't accidentally get
	duplicates on the stack from out of sequence push operations. 

Thu Apr  4 12:22:35 1996  Ian Searle  <ians@localhost>

	* opmat.c (element_multiply): Add proper error handling if first
	arg is UNDEF.

	* main.c (MAIN__): Added dummy MAIN__ to shut up compiles with
	libf2c. 

	* (configure.in): Updated some of the library checks to work with
	the more restrictive ld(1).

Sat Feb 10 20:53:23 1996  Ian Searle  <ians@espresso.org>

	* rlab.y: New list productions. Fixes some old shortcuts I
	took. Thanks to Frank Muennemann.

Sun Dec 10 20:22:42 1995  Ian Searle  <ians@espresso.org>

	* mathl.c (matherr): Return default on underflow.

Sat Dec  9 22:28:03 1995  Ian Searle  <ians@espresso.org>

	*  Added readline history mechanism, courtesy of Mel Melchner.

Thu Nov  9 07:12:23 1995  Ian Searle  <ians@espresso.org>

	* math_3.c (matrix_is_symm): Fixed complex-hermitian check.

Sun Jun 11 23:00:02 1995  Ian Searle  <ian@espresso>

	* Makefile.in (install): Make symbolic links relative.

Sun May 28 17:34:20 1995  Ian Searle  <ian@espresso>

	* I think I finally got rlab to work OK without a trailing newline
	at the end of each file. This involved defining my own EOF (REOF)
	with an <<EOF>>  { return REOF; } in scan.l (this requires
	flex). Then there are some additional rules in rlab.y to
	understand REOF.

Wed May 24 17:22:23 1995  Ian Searle  <ian@espresso>

	* bltin1.c (ReadM): Added optional second argument to specify rows
	and columns.

Sat May 20 18:04:14 1995  Ian Searle  <ian@espresso>

	* misc/plplot.r (plpoint): New function.
	(plline): New function.

Fri May 19 20:27:16 1995  Ian Searle  <ian@espresso>

	* r_plot.c (_plot_plprint): Don't close the file when done, then
	users can write to the file some more later on.

Sat May 13 13:48:37 1995  Ian Searle  <ian@espresso>

	* getline.c (Strsplt): Use matrix_Truncate in case the splitting
	stops short.

	* matrix.c (matrix_Truncate): Add in trucate operation for string
	matrices. 

Fri May 12 17:26:48 1995  Ian Searle  <ian@espresso>

	* r_string.c (string_add): Add some error checking to string
	addition. 

Thu May 11 19:56:34 1995  Ian Searle  <ian@espresso>

	* rdl.c (DLopen): Added OS/2 dynamic linking stuff, courtesy of
	John Peterson.

Wed May 10 20:06:56 1995  Ian Searle  <ian@espresso>

	* main.c (init_tc_environment): More changes from John P. Again,
	these are generalizations

	* print.c (get_file_ds): John suggested some changes THINK_C ->
	HAVE_PIPE. 

Tue May  9 20:09:23 1995  Ian Searle  <ian@espresso>

	* bio.c (scalar_ReadB): Added this back in for backward
	compatibility. 

Sat Apr 29 00:17:15 1995  Ian Searle  <ian@espresso>

	* matrix.c (matrix_Copy): Trivial changes in matrix-copy to save
	time. 
	(matrix_Destroy): Trivial changes to save time.

Tue Apr 25 20:30:18 1995  Ian Searle  <ian@espresso>

	* bltin1.c (Read): Add backward compatible scalar read().

Mon Apr 24 20:39:29 1995  Ian Searle  <ian@espresso>

	* mathl.h (r_ieee754_double): New structure.

	* mathl.c (rfrexp): New function.

	* opmat.c (matrix_assign): Add fast matrix assign back.

Sun Apr 23 20:55:19 1995  Ian Searle  <ian@espresso>

	* Added several functions: matrix_convert_real(),
	matrix_convert_complex(), bltin_get_numeric_matrixR(),
	bltin_get_numeric_matrixC(). These are used in r_plot.c alot,
	cause the plotting only handles real numbers. And, now that there
	are no more scalars, we must be more careful.

Fri Apr 21 19:49:12 1995  Ian Searle  <ian@espresso>

	* MAJOR changes. Got rid of Scalars (internally). The internals
	now deal exclusively with matrices (for numeric work, there are
	still scalar strings).

Thu Apr 20 14:03:56 1995  Ian Searle  <ian@espresso>

	* matrix.c (matrix_read_string): Modify to handle any type of
	matrix string element.

	* matop1.c (matrix_eq): Make sure to copy temp string, so we don't
	destroy the original.

	* main.c (init_tc_environment): Changed a few remaining malloc()
	to MALLOC().

Sun Apr 16 12:37:38 1995  Ian Searle  <ian@espresso>

	* test (xsm): Add string scalar/matrix append test.

Sun Mar 26 19:26:27 1995  Ian R. Searle  <ian@espresso>

	* configure.in: Add some more options for OSF cc.

	* getline.c (Strsplt): Remove floor() usage. It is not really
	needed, and this way brain-dead HP-UX produce working code.

Sat Mar 25 09:50:16 1995  Ian R. Searle  <ian@espresso>

	* fpe.c: Fix def flag inconsitency (affects OSF machines).

	* configure.in: Add CC def for OSF.

Sun Mar 19 19:15:52 1995  Ian R. Searle  <ian@espresso>

	* scan.l: Fixed lineno counting problem with comments...

Mon Mar 13 10:21:16 1995  Ian R. Searle  <ian@espresso>

	* rlib/printmat.r (printmat): Some more minor adjustments to get
	things to line up a little better.

	* bltin1.c: make length return string length for 1-by-1 string
	matrix. 
	(Format): Make format() return a matrix (1-by-2) of the OLD format
	values. Also make format() take a matrix as input.

Sun Mar 12 20:07:54 1995  Ian R. Searle  <ian@espresso>

	* rlib/printmat.r (printmat): Add some simple error checking, and
	touch up comments.

Mon Mar  6 07:07:49 1995  Ian R. Searle  <ian@espresso>

	* Makefile.in (distclean): Clean up the commands some.

Sun Mar  5 10:27:59 1995  Ian R. Searle  <ian@espresso>

	* toolbox/lagrange.r (lagrange): Fixed bug reported by Karl S. 
	(i != [])

	* toolbox/roots.r: New roots() from Tzong-Shuoh Yang.

	* misc/plplot.r (plot): Add textf so plotting on DOS-like systems
	can have the option not to return to text mode. This is very
	useful for doing multi-plot pages.

	* test (sprintf test): Added more complexity to test coercion.

	* print.c (do_printf): Really coerce all matrices into scalars.

	* util.c (convert_to_scalar_really): New function.

Sat Mar  4 23:30:07 1995  Ian R. Searle  <ian@espresso>

	* opmat.c (matrix_vector_sub): Try commenting out the business
	where we convert a[1] or a[1;1] to a scalar, cause it has scalar
	dimension.

	* misc/gnuplot.r: Update from Karl.

Wed Feb 22 18:30:26 1995  Ian Searle  <ian@espresso>

	* configure.in: CC options for AIX.

	* matrix.c (matrix_AssignRow): Fix embarrasing bug in matrix
	assignment... missing the `=' in `<='.

Sat Feb 18 09:55:35 1995  Ian Searle  <ian@espresso>

	* config.h.in: Use `#ifdef __STDC__' instead of `#if __STDC__'.

	* configure.in: Always remove config.cache at the conclusion of
	each configure.

Thu Feb 16 18:34:08 1995  Ian Searle  <ian@espresso>

	* opmat.c (matrix_assign): Fix 'a[i;j] = a' problem.
	(matrix_vector_assign): Same.

Mon Feb 13 20:53:42 1995  Ian Searle  <ian@espresso>

	* matop1.c (matrix_scalar_ne): Special case SCALAR != [].
	(matrix_scalar_eq): Same.
	(matrix_eq): Same.
	(matrix_ne): Same.

Sat Feb 11 20:20:47 1995  Ian Searle  <ian@espresso>

	* opmat.c (matrix_reshape_col): Special case when arg = []

Fri Feb 10 20:20:49 1995  Ian Searle  <ian@espresso>

	* help/eig: Updated this help file.

	* bltin1.c (Members): Change `List' to `L'.

Sun Feb  5 19:39:05 1995  Ian Searle  <ian@espresso>

	* fi_1.c (matrix_Eig_GNEPa): Fixed core dump due to wrong starting
	index in eval computation.
	(matrix_Eig_GNEPa): Order of arguments backwards, left and right
	eigenvectors switched.

Sat Feb  4 08:34:32 1995  Ian Searle  <ian@espresso>

	* Release v1.18a

	* getline.c (Strsplt): Added 2nd arg to split on strings or field
	widths. 

	* util.c (cpnstr): New function.

	* getline.c (Getline): Make reading in a single string faster.

Thu Jan 26 19:56:22 1995  Ian Searle  <ian@espresso>

	* getline.c (Getline): Check for EOF, with 2nd arg.

Tue Jan 24 20:08:59 1995  Ian Searle  <ian@espresso>

	* Version 1.17d released.

	* rfile.c (require): Check to see if the variable required is an
	UNDEF. 

Sun Jan 22 19:46:44 1995  Ian Searle  <ian@espresso>

	* test (listest): Add open-list assignment test.

	* code.c (olist_assign): New function.

Mon Jan 16 23:16:05 1995  Ian Searle  <ian@espresso>

	* rlib/intersection.r (intersection): Initialize Int=[]. Thanks
	Rogelio Oliva.

Sun Jan 15 18:58:43 1995  Ian Searle  <ian@espresso>

	* math_1.c (Frexp): New function.

Tue Jan 10 19:01:56 1995  Ian Searle  <ian@espresso>

	* rlib/input.r (input): Check STRING arg to see if it exists.

Sun Jan  8 12:05:58 1995  Ian Searle  <ian@espresso>

	* getline.c (Getline): Allow getline to read in an entire line as
	a single string.

Mon Jan  2 10:26:55 1995  Ian Searle  <ian@espresso>

	* bio.c (btree_WriteB): Write the number of _real_ nodes in the
	tree. 

	* btree.c (btree_Write): Write the number of _real_ nodes in the
	tree. 

Tue Dec 27 00:17:37 1994  Ian Searle  <ian@espresso>

	*  (toolbox/hilbert.r): New file.

	* math_2.c (Norm): Compute infinity norm when 2nd argument to
	norm() is an Inf.

Mon Dec 26 12:26:54 1994  Ian Searle  <ian@espresso>

	* scan.l: Increment lineno on end of RFILE_COND and REQ_COND.

Fri Dec 23 14:20:54 1994  Ian Searle  <ian@espresso>

	* Version 1.16b released...

Thu Dec 22 20:51:27 1994  Ian Searle  <ian@espresso>

	*  (doc/rlabp.tex): Incorporated Dave Raymon's primer patches so
	that is works OK under laTeX-2e.

Sun Dec 18 18:27:07 1994  Ian Searle  <ian@espresso>

	* rfile.c (require): New function.

	* bltin2.c: Set tictime to -1 (initialize) so it works on older
	SunOSes.

Fri Dec 16 20:41:01 1994  Ian Searle  <ian@espresso>

	* fpe.c: Added include <math.h> for HP-UX.
	Added some stuff for the DEC-alpha (still doesn't work like I want
	it to).

	* bltin2.c (Tic): Use sysconf instead of CLK_TCK.

Thu Dec 15 22:01:20 1994  Ian Searle  <ian@espresso>

	* r_plot.c: Change header includes per tsy's suggestions. 
	Go back... plConfig.h is only installed for Mac and Amigas. Causes
	problems with Unix installations.

Mon Dec 12 22:54:11 1994  Ian Searle  <ian@espresso>

	* fpe.c: Add in change for those systems that don't have either
	ieee_handler or ieeefp.h (linux).

Sun Dec 11 16:42:33 1994  Ian Searle  <ian@espresso>

	* scan.l: Fix lineno counting on comments.

	* Release version 1.15e.

Sat Dec 10 11:30:10 1994  Ian Searle  <ian@espresso>

	* rfile.c (rfile_load): Mods to handle multiple file names, and
	deal with optional `.r'.
	(rfile_ext): New function.

	* scan.l: Overhaul rfile command scanning.

	* util.c (strappend): New function.

Thu Dec  8 19:20:07 1994  ian  <ian@espresso>

	* scan.l: Add Matlab style comments as an option.

Fri Dec  2 20:15:30 1994  ian  <ian@espresso>

	* scan.l: Allow comments on the same line as rfile and help.

Wed Nov 30 19:09:30 1994  ian  <ian@espresso>

	* rlib/compan.r: fixed bug in computation of A when n == 2.

Sun Nov 27 18:48:40 1994  ian  <ian@espresso>

	* misc/plplot.r: Several little mods: Added set3d(), mods to
	pclose(), and subplot().

	* bltin2.c (Toc): New functions, utilizing times(), a more
	accurate measurment device.

Thu Nov 24 10:44:49 1994  ian  <ian@espresso>

	* Update configure.in, Makefile.in, etc to use autoconf v2.x

Wed Nov 16 23:23:49 1994  ian  <ian@espresso>

	* Just moved the entire code-tree over to espresso (my new
	Pentium). 

Wed Nov  9 21:53:35 1994  Ian Searle  <ian@quixote>

	* symbol.c (install_tmp_switch): Add BLTIN to switch.

	* code.c (bltin): Get the listnode on the tmplist for assign().

	* rdl.c (DLopen): Return a bltin, not a listnode.

Tue Nov  8 06:16:06 1994  Ian Searle  <ian@quixote>

	* code.c (load_local_var): Use cpstr() for pass by value.

	* misc/plplot.r (pclose): Modify so that it can handle closing
	when no plot windows exist.

Sun Nov  6 09:45:05 1994  Ian Searle  <ian@quixote>

	* Release v1.15b

Sat Oct 29 09:31:07 1994  Ian Searle  <ian@quixote>

	* function.c (function_setup2): Cut back size of program array. 

	* code.c (list_create): Change list-element create name to "-L-". 

	* Revised all flow-control logic. Instead of using ifcode(),
	forcode(), whilecode(), the parser now generates codes for
	conditional jumps and for loop construction with explicit
	jumps. This required significant changes to main.c, rlab.y
	code.[ch], diss.c, etc...

Fri Oct 28 23:17:15 1994  Ian Searle  <ian@quixote>

	* scalar.c (scalar_CreateC): Remove references to obsolete `dtype'
	structure member.

	* symbol.c (install_tmp): Change tmplist scheme to include a
	tmpstack of already allocated ListNodes in an effort to save time
	during execution.

Fri Oct 21 20:50:50 1994  Ian Searle  <ian@quixote>

	* Release v1.13b.

Sat Oct  8 15:30:53 1994  Ian Searle  <ian@quixote>

	* fi_1.c (matrix_Det_Complex): Warn and return zero when matrix is
	singular. 
	(matrix_Det_Real): Same as above.

Thu Oct  6 20:02:14 1994  Ian Searle  <ian@quixote>

	* code.c (copy_arg): Copy name to data structure.

Fri Sep 30 20:11:13 1994  Ian Searle  <ian@quixote>

	* scan.l (new_file): Try and repair some small mem leaks (bst).

	* util.c (btree_members): Fix memory leak (bst).

Thu Sep 29 23:05:11 1994  Ian Searle  <ian@quixote>

	* misc/plplot.r (plot3): Take care of log-log-log data
	possibility. 

Wed Sep 28 19:36:39 1994  Ian Searle  <ian@quixote>

	* odei.c (odei): Add optional last argument (8), a user supplied
	output function.
	(out_func): New function.

Sun Sep 25 19:46:29 1994  Ian Searle  <ian@quixote>

	* matop2.c (matrix_ReadGeneric): Check fscanf() return value.

Sat Sep 24 11:27:43 1994  Ian Searle  <ian@quixote>

	* code.c (load_local_var): Add nargin initialization.

	* misc/plplot.r: Check for previously existing WIN
	before creating new one.

Mon Sep 19 18:33:14 1994  Ian Searle  <ian@quixote>

	* BIG CHANGE: Undeclared function variables are default local
	now. 

Sat Sep 17 09:13:57 1994  Ian Searle  <ian@quixote>

	* configure.in: Make configure look for plplot in
	/usr/local/plplot and /usr/local/... Also make trying to use
	dynamic linking standard, and well as using the case statement for
	option flags.

Thu Sep 15 17:12:56 1994  Ian Searle  <ian@quixote>

	* misc/plplot.r (y_scales): More bug fixes in y_scale().

Tue Sep 13 22:20:15 1994  Ian Searle  <ian@quixote>

	* r_plot.c (_plot_plsfile): New function.

Mon Sep 12 20:31:29 1994  Ian Searle  <ian@quixote>

	* rdl.c (DLopen): Check for RTLD_NOW.

	* print.c (SPrintf): Change argument cleanup... use inlined
	clean-up function...

	* math_1.c (Floor): Try and recover some speed from earlier
	changes... 

Sat Sep 10 23:19:33 1994  Ian Searle  <ian@quixote>

	* Major overhaul to built-in function argument handling. Instead
	of bltin() handling the argument tmp-cleanup, each builtin is now
	responsible. This may sound more difficult, but it will be easier
	in the long run, especially for people writing rex files.

Sun Sep  4 12:26:43 1994  Ian Searle  (ian@quixote)

	* main.c (Eval): Make eval() work with any kind of string (matrix,
	or scalar).

	* test: New tests for factor/backsub, real/complex ,
	general/symmetric. 

	* Add symmetric linear equation solver usage for solve(), `\',
	factor, and backsub.

Wed Aug 24 19:15:31 1994  Ian Searle  (ian@quixote)

	* bltin2.c (Putenv): New function.

	* configure.in: Some bug fixes, and improvements...

Tue Aug 23 17:42:42 1994  Ian Searle  (ian@quixote)

	* function.c (function_Copy): Always create arg and local lists on
	copy. 

Mon Aug 22 23:21:58 1994  Ian Searle  (ian@quixote)

	* matop2.c (matrix_Pow2): Added more complete checking of
	element-by-element power ops for various combinations of scalars
	and matrices.
	(matrix_matrix_el_pow): Check individual matrix entries for proper
	conditions. 

Sun Aug 21 00:22:58 1994  Ian Searle  (ian@quixote)

	* r_plot.c (_plot_plvasp): New function.
	(_plot_plvpas): New function.

	* code.c (userf): Had the names in bacwards order.

Tue Aug 16 22:51:53 1994  Ian Searle  (ian@quixote)

	* misc/plplot.r (subplot): New function.

	* configure.in: Check for working rint.

Mon Aug 15 18:24:27 1994  Ian Searle  (ian@quixote)

	* bio.c: Fix four-byte word size.

Sun Aug 14 22:05:22 1994  Ian Searle  (ian@quixote)

	* Makefile.a: Use version number for TOPDIR.

Sat Aug 13 07:28:38 1994  Ian Searle  (ian@quixote)

	* r_plot.c (_plot_plstart): Add server no kill code for new plplot
	(4.99h). 

Wed Aug 10 18:20:41 1994  Ian Searle  (ian@quixote)

	* util.c (fpecatch): More EMX changes (re-enable signal()).

	* code.c (intcatch_wait): Some changes to support EMX (OS/2).

Tue Aug  9 03:46:10 1994  Ian Searle  (ian@quixote)

	* matop2.c (matrix_matrix_Pow): New function.
	(matrix_scalar_Pow1): Add 1-by-1 special case.

	* opmat.c (matrix_assign): Reset matrix name after re-init.

	* rdl.c (DLopen): Add dlerror() usage to dlsym() call.

Mon Aug  8 18:29:38 1994  Ian Searle  (ian@quixote)

	* matrix.c (matrix_read_string): Eat up last new line. 
	(matrix_Read): Return early from string read.

Sun Aug  7 12:24:35 1994  Ian Searle  (ian@quixote)

	* Makefile.a: New file. Actually this is the original
	Makefile.in. Now either Makefile.so or Makefile.a gets copied to
	Makefile.in during configure.

	* Makefile.so: New file

	* Adding support for dynamic linking.

	* util.c (call_rlab_script): Remove check for number of arguments,
	this is done in userf already, and is not valid if the function is
	a builtin.

Tue Aug  2 23:50:29 1994  Ian Searle  (ian@quixote)

	* code.c: Clean up memory inefficieny in list member references.

Fri Jul 29 20:17:09 1994  Ian Searle  (ian@quixote)

	* Many changes to almost all files. Re-organize to reduce global
	variable usage, and increase modularity (for dynamic linking).

	* code.c: Convert global variables to static.

Thu Jul 28 22:17:09 1994  Ian Searle  (ian@quixote)

	* code.c (whilecode): All this time and I was neglecting to clean
	the conditional Datums...
	(ifcode): Same as whilecode...

	* matop2.c (matrix_ReadGeneric): Fix to allow spaces after last
	row element. Re-work 1st line logic.

Thu Jul 21 22:33:18 1994  Ian Searle  (ian@quixote)

	* install.sh: Switch to X11R5 install.sh.

Tue Jul 19 22:46:27 1994  Ian Searle  (ian@quixote)

	* fi_1.c: Added matrix_Detect_Inf and matrix_Detect_Nan calls.

	* matop3.c (matrix_Detect_Inf): New function.
	(matrix_Detect_Nan): New function.

	* util.c: Removed a few no-longer used functions.

Mon Jul 18 19:33:26 1994  Ian Searle  (ian@quixote)

	* code.c (assign): Rework LHS checking for a teeny bit of speed.

	* op.c (ent_ent_add): Flatten switches.

Sun Jul 17 00:57:06 1994  Ian Searle  (ian@quixote)

	* matop2.c (matrix_matrix_el_pow): Handle 1-by-1 matrices.

	* code.c (execute): Change for to a while to speed things up a
	tad. 

	* opmat.c (matrix_assign): Speed up a[i;j] = x, where i and j are
	scalars. 

	* matrix.c (matrix_Assign_el): New function.

Sat Jul 16 15:14:40 1994  Ian Searle  (ian@quixote)

	* main.c (run_program_eval): Modify to only call yyparse once. 

	* code.c (forcode): Cleanup changes to forcode for readability.

Tue Jul 12 17:22:36 1994  Ian Searle  (ian@quixote)

	* matop2.c (matrix_Sign): New function.

Mon Jul 11 18:11:50 1994  Ian Searle  (ian@quixote)

	* listnode.h (listNode_GetKey): Make it a macro (faster).

Sat Jul  9 17:03:36 1994  Ian Searle  (ian@quixote)

	* bltin2.c (Eval): New function. Also affects scan.l, and
	main.c. Now eval() will read from a string without the temporary
	file. 

	* scan.l (set_rlab_input): New function.

Thu Jul  7 20:37:51 1994  Ian Searle  (ian@quixote)

	* code.c (list_assign): Missing break.

Wed Jul  6 21:42:49 1994  Ian Searle  (ian@quixote)

	* bio.c (Fseek): New function.
	(Fread): New function.

Tue Jul  5 17:50:29 1994  Ian Searle  (ian@quixote)

	* matrix.c (matrix_Truncate): Check size before truncating.

Sun Jun 26 08:48:01 1994  Ian Searle  (ian@quixote)

	* Release v1.02

	* misc/plplot.r (grid_y_default): Make default grid without grid
	lines at tick intervals.

Wed Jun 22 22:36:50 1994  Ian Searle  (ian@quixote)

	* bltin2.c (Tmpfile): New function.

Sun Jun 12 09:23:21 1994  Ian Searle  (ian@quixote)

	* toolbox/toeplitz.r: Revise contributed toeplitz so that it will
	handle size(C) != size(R). Note that it still will not perform
	like Matlab's for the complex case.

Sat Jun 11 21:58:16 1994  Ian Searle  (ian@quixote)

	* misc/plplot.r (plhold_off): Add call to _pltext() to reset to
	text mode.

	* matop2.c (matrix_ReadGeneric): Improvments to handle last lines
	without terminating newline characters.

Thu Jun  9 17:18:23 1994  Ian Searle  (ian@quixote)

	* r_plot.c (_plot_plscol0): New function.

	* matop2.c (matrix_ReadGeneric): Make readm() more efficient.

Tue Jun  7 18:45:37 1994  Ian Searle  (ian@quixote)

	* Makefile.in: Remove obsolete targets from Makefile.

	* getline.c (Getline): Fix stupid string error.

Mon Jun  6 17:24:16 1994  Ian Searle  (ian@quixote)

	* fi_1.c (matrix_Eig_NEP): Fix overwrites problem with
	left-eigenvectors. 

Sun Jun  5 20:20:32 1994  Ian Searle  (ian@quixote)

	* Release Version 1.0.

Tue May 24 16:55:15 1994  Ian Searle  (ian@quixote)

	* fi_1.c (solve_eq): Add calls to [DZ]GECON for input matrix
	condition check.
	(solve_eq): Mods to make A ill-conditioning handling more uniform,
	as well as error messages.

	* matrix.c (matrix_Assign): Make row and column index requirements
	looser. 
	(matrix_ExtractColumn): Same.
	(matrix_ExtractRow): Same
	(matrix_ExtractColMatrix): Same.
	(matrix_ExtractRowMatrix): Same.

Fri May 20 20:19:02 1994  Ian Searle  (ian@quixote)

	* symbol.c (symbol_table_create): Set the name of $$.

	* btree.c (btree_CopyTree): Check for $$.

	* code.c (copy_arg): New function.
	(load_local_var): Copy arg variables if they are declared local.

Wed May 18 18:23:55 1994  Ian Searle  (ian@quixote)

	* matrix.c (matrix_AssignRow): Be more relaxed with matrix index
	dimensions in assignments, and allow [] as assignment index.

Mon May 16 19:31:02 1994  Ian Searle  (ian@quixote)

	* fi_1.c (matrix_Eig_GNEPa): slightly more descriptive error
	message. 

Fri May 13 22:07:52 1994  Ian Searle  (ian@quixote)

	* bltin1.c (Reshape): Use targ1 in arglist.

Tue May 10 19:20:41 1994  Ian Searle  (ian@quixote)

	* matop3.c (matrix_PNorm): New function.

Mon May  9 01:21:39 1994  Ian Searle  (ian@quixote)

	* fftp.h: Change defines to use newer fftpack calls. Same
	arguments, etc, just added a `D' or `d' to the front of the name.

	* matop2.c (matrix_Find): Change && to || in find-complex logic.

	* bltin2.c (Find): Add usage of TARG_DESTROY.

	* code.c (ret_from_func): Search local list object with pointer
	value. 

	* btree.c (btree_find_node_r): Had to make this function search
	the list looking for nodes based upon pointer value.

Sun May  8 14:54:04 1994  Ian Searle  (ian@quixote)

	* r_plot.c (_plot_plptex): Make last argument be ["s"] or "s".

	* util.c (matrix_to_scalar): Add else-if option for STRING
	matrices (can't believe this was used like this ?).

	* misc/plplot.r: Added plhold(), plhold_off(). Also added variable
	line/point styles for the same plot.

Wed May  4 21:48:05 1994  Ian Searle  (ian@quixote)

	* matop3.h: New file.

	* matop3.c: New file.

	* math_2.c (Max): Make max compatible with Matlab (2 args).
	(Min): Make min compatible with Matlab (2 args).

Mon May  2 06:30:08 1994  Ian Searle  (ian@quixote)

	* Release v0_99f.

	* Added plmesh() (to plplot.r) via r_plot.[ch].

	* listnode.c (listNode_isValid): Add listNode_isValid back in.

	* Release v0_99e (to tsyang).

Sun May  1 14:12:18 1994  Ian Searle  (ian@quixote)

	* rfile.c (get_rlab_search_path): New function.

Sat Apr 30 10:27:13 1994  Ian Searle  (ian@quixote)

	* Release v0_99d

	* util.c (call_rlab_script): Oops, make rlab_call_script handle
	builtin functions as well.

	* odei.c (odei): Add error check to dtout (!= 0)
	(odei): Moved TARG_DESTROY usage down to bottom of function where
	it belongs.

Fri Apr 29 22:06:36 1994  Ian Searle  (ian@quixote)

	* bio.c (GetB): New function.

	* r_string.c (string_Write): Add call to fflush ().

	* bltin1.c (btree_write): Add call to fflush ().

	* scalar.c (scalar_Write): Added call to fflush().

Tue Apr 26 20:01:38 1994  Ian Searle  (ian@quixote)

	* main.c: Add -h to usage string.

	* print.c (get_file_ds): Added setvbuf, and buffsize.

	* bltin1.c (Read): Removed pre-cautionary close_file_ds() at
	beginning. 

	* bio.c (ReadB): Removed pre-cautionary close_file_ds() at
	beginning. 

	* rlab.y: Set $$ on [] to avoid confusing if().

	* diss.c (print_code_var): Print diss() from core dumping when a
	pushed variable has no key.

	* bltin2.c (FVScope): Update for OP_ELADD and OP_EL_SUB.

	* diss.c (diss_assemble): Update for OP_EL_ADD and OP_EL_SUB. 

Sat Apr 23 08:58:23 1994  Ian Searle  (ian@quixote)

	* Release v0.99b

	* code.c (intcatch_wait): Mods to prevent unwanted termination
	from multiple ^C.

	* matop2.c (matrix_Pow1): Fix a.^0 computation.

Tue Apr 12 21:27:56 1994  Ian Searle  (ian@quixote)

	* scan.l: Add .+ .-

Fri Apr  8 22:17:47 1994  Ian Searle  (ian@quixote)

	* code.c (list_assign): Allow 1st element of matrix as list index
	for conversion to string.

	* rfile.c (cat_help_file_DOS): New function, added as a DOS
	bandaid.

Tue Apr  5 17:13:17 1994  Ian Searle  (ian@quixote)

	* bio.c: Changed "r" and "w" to "rb" and "wb".

Sun Apr  3 18:07:20 1994  Ian Searle  (ian@quixote)

	* scan.l (rlab_yy_input): Added some code to feed flex a dummy
	line if it has already read the '\n' before a flush_line occurs.

Tue Mar 29 21:19:13 1994  Ian Searle  (ian@quixote)

	* Renamed a bunch of files. Should be better now on crippled OSes.

	* matop2.c (matrix_VectorAddCol): New function.
	(matrix_VectorAddRow): New function.

Sun Mar 27 18:17:40 1994  Ian Searle  (ian@quixote)

	* bltin2.c: Added #include <time.h> for tic() and toc().

	* rfile.c: Added #ifdefs for DOS inablility to handle popen in
	rfile and help commands.

Thu Mar 24 21:35:57 1994  Ian Searle  (ian@quixote)

	* math_3.c (Filter): New function.

Sat Mar 19 00:22:52 1994  Ian Searle  (ian@quixote)

	* Break bltin.c into bltin1.c and bltin2.c.

Fri Mar 18 23:50:51 1994  Ian Searle  (ian@quixote)

	* test (l): Added ascii I/O tests.

Wed Mar 16 18:45:53 1994  Ian Searle  (ian@quixote)

	* bltin.c (Read): Removed fseek() and ftell() usage from read().

Mon Mar 14 20:09:59 1994  Ian Searle  (ian@quixote)

	* Dump rksuite, and replace with ode.f. Rename rks* to ode*.

	* matrix_op2.c (matrix_ReadGeneric): Overhaul readm() so that it
	can read from pipes, or from the middle of a file...

Tue Mar  8 23:41:30 1994  Ian Searle  (ian@quixote)

	* rksi.f: New file.

	* rksi.h: New file.

	* rksuite.f: New file.

	*  rks.c: New file.

Tue Mar  1 21:35:46 1994  Ian Searle  (ian@quixote)

	* bio.c (scalar_ReadB): Remove extraneous strlen() call.
	(matrix_ReadB): Remove old index usage.

Sun Feb 27 12:08:00 1994  Ian Searle  (ian@quixote)

	* test: Added binary file I/O tests.

Sat Feb 26 23:13:20 1994  Ian Searle  (ian@quixote)

	* bio.c: Changes to make matrix output MATLAB compatible.

Thu Feb 24 17:18:58 1994  Ian Searle  (ian@quixote)

	* rlib/save.r (save): Use writeb() instead of write().

Sun Feb 20 20:26:30 1994  Ian Searle  (ian@quixote)

	* bi_io.c: New file, contains binary file I/O functions.

Sat Feb 19 21:37:24 1994  Ian Searle  (ian@quixote)

	* bltin.c (Write): Fix write() so that argument checking is
	correct. 

	* getline.c (Getline): Make getline() return a NULL string if a
	blank line is encountered.

Tue Feb  8 20:41:42 1994  Ian Searle  (ian@quixote)

	* matrix_op2.c (matrix_Acos): Same change as below...

	* scalar_op1.c (scalar_Acos): Same change as below...

	* trig.c (Asin): Make asin() and acos() work for values >= 1.

Mon Feb  7 17:49:05 1994  Ian Searle  (ian@quixote)

	* bltin.c (Reshape): Make reshape() accept scalar numeric values. 

Sun Feb  6 22:18:51 1994  Ian Searle  (ian@quixote)

	* toolbox/nmsmax.r: New function.

	* toolbox/mdsmax.r: New function.

Sat Feb  5 22:07:39 1994  Ian Searle  (ian@quixote)

	* code.c (function_call): Numerous changes and restructuring to
	make code more functional, and allow usage from other C source
	code (getting ready for dynamic linking).

Fri Feb  4 23:04:58 1994  Ian Searle  (ian@quixote)

	* util.c (call_rlab_script): New function.

	* code.c (userf): New function.

Sun Jan 30 16:35:17 1994  Ian Searle  (ian@quixote)

	* Makefile.in: Made changes to Makefile to make non-UNIX usage
	easier (OS/2, DOS, etc...).

Tue Jan 25 05:31:52 1994  Ian Searle  (ian@quixote)

	* toolbox/window.r (window): Return a column vector.

Thu Jan 20 17:11:08 1994  Ian Searle  (ian@quixote)

	* math_3.c (SchOrd): New function.

	* fi_2.c (matrix_Schur_Reorder): New function.

Sat Jan  8 13:58:50 1994  Ian Searle  (ian@quixote)

	* matrix_op1.c (matrix_scalar_eq): Allow equality tests between
	matrices of numbers, and strings.
	(matrix_scalar_ne): Allow equality tests between matrices of
	numbers, and strings.

Fri Jan  7 20:39:05 1994  Ian Searle  (ian@quixote)

	* matrix_op1.c (matrix_ne): Allow equality tests between matrices
	of numbers, and strings.
	(matrix_eq): Allow equality tests between matrices of numbers, and
	strings. 

	* matrix_op2.c (matrix_string_eq): Allow equality tests between
	matrices, and strings.

	* relation.c (ent_ent_eq): Allow equality tests between scalars
	and strings

Tue Jan  4 21:55:23 1994  Ian Searle  (ian@quixote)

	* test: Added lu/factor tests.

Tue Dec 14 19:11:49 1993  Ian Searle  (ian@quixote)

	* code.c (init_frame): New functions.

Mon Dec 13 17:24:29 1993  Ian Searle  (ian@quixote)

	* rfile.c (path_split): Make ':' a static variable called
	PATHT_SEP so non-Unix platforms can change it easily.

Sun Dec 12 21:27:19 1993  Ian Searle  (ian@quixote)

	* code.c (find_lineno): Added a fail-safe so that we don't back
	off of the code-stack.

Sat Dec 11 14:51:39 1993  Ian Searle  (ian@quixote)

	* rlab.y (ryyerror): Started using flush_line again. This time I
	got it working :-).

	* btree.c (btree_sizeof): New function.

	* bltin.c (Sizeof): New function.

Mon Dec  6 19:48:29 1993  Ian Searle  (ian@quixote)

	* Switch to using flex-2.4.3

Fri Dec  3 23:14:12 1993  Ian Searle  (ian@quixote)

	* r_plot.c (_plot_plspause): New function.

Thu Dec  2 21:05:15 1993  Ian Searle  (ian@quixote)

	* print.c (rfile_Destroy): Remove if test, and error message from
	fclose(). 

Wed Dec  1 19:12:16 1993  Ian Searle  (ian@quixote)

	* bltin.c (Strtod): Make strtod take matrices as well.

	* rlib/plplot.r: More updates to plplot.r

Tue Nov 23 19:05:09 1993  Ian Searle  (ian@quixote)

	* test: Many additional tests added.

	*  (fi_?.c): Changed all comparisons between ints and long ints
	(info). 

	* r_plot.c (_plot_plprint): Added plflush(), and plend1().

Mon Nov 22 21:42:05 1993  Ian Searle  (ian@quixote)

	* test (a): Added matrix relational tests.

	* matrix_op1.c (matrix_lt): Fix typo.

Sun Nov 21 20:56:29 1993  Ian Searle  (ian@quixote)

	* bltin.c (Strtod): New function.

Wed Nov 17 19:15:09 1993  Ian Searle  (ian@quixote)

	* init.c: Add in PLPLOT code.

	* random.c (Rand): Change back to f2c *.f for ranlib, and make
	necessary type casts in random.[ch]

	* math_3.c (FFT): Add F_INT declarations to avoid alignment
	problems. 

Tue Nov 16 19:49:39 1993  Ian Searle  (ian@quixote)

	* config.h.in: Add #else #include <malloc.h>

	* mem.h: Remove #ifdef __STDC__ , and let config.h take care of
	stdlib.h, or malloc.h.

Mon Nov 15 17:16:37 1993  Ian Searle  (ian@quixote)

	* matrix_op1.c (matrix_MultiplyCC): Must make sure to use ints
	that are F_INT with BLAS subroutines.

Sat Nov 13 11:50:57 1993  Ian Searle  (ian@quixote)

	* LOTS of changes for improved fortran interface: New lp.[fh],
	bl.[fh], and fi.h. Many mods to fi_1.c, and fi_2.c

Fri Nov 12 21:09:37 1993  Ian Searle  (ian@quixote)

	* mathl.c (Rrint): Rename rint() so that it can be used on systems
	with broken rint().

Wed Nov 10 22:14:59 1993  Ian Searle  (ian@quixote)

	* math_2.c (Eig): Take all the argument overloading out of eig(),
	now eig() just does eig(A), or eig(A, B).

Fri Nov  5 17:25:14 1993  Ian Searle  (ian@quixote)

	* math_2.c (Eig): Added "u" option.

Sat Oct 30 20:57:30 1993  Ian Searle  (ian@quixote)

	* btree.c (btree_Print): Add list name printing (like scalars
	matrices, and strings).

	* r_string.c (string_Print): New function.

	* matrix.c (matrix_Print): Don't print out variable with "-N"
	name, (function arguments).

	* scalar.c (scalar_Print): Don't print out variable with "-N" name
	(function arguments).

	* main.c (main): Add -h option, prints out error message.

Fri Oct 29 19:20:07 1993  Ian Searle  (ian@quixote)

	* code.c (list_assign): Left g out of sprintf() format.

Tue Oct 26 18:54:38 1993  Ian Searle  (ian@quixote)

	* Obtained new getopt related files from the GNU libc.

Sat Oct 23 09:21:56 1993  Ian Searle  (ian@quixote)

	* bltin.c (Read): Now taks a 2nd argument (optional) which
	specifies a list that the data can be installed onto.

	* rlib/fix.r (fix): Mods to function from bradh to handle complex.

	* trig.c (Atan2): More generic now.

	* matrix_op2.c (matrix_Atan2): Added 1-by-1 checks.

Fri Oct 22 21:04:07 1993  Ian Searle  (ian@quixote)

	* rlib/finite.r (finite): Return TRUE if element is finite.

	* math_1.c (Mod): Mods to handle combinations of different size
	matrices. 

	* matrix_op2.c (matrix_Mod): Mods to handle  1-by-1 matrices.

	* config.h.in: Fix logic surrounding FP_SET_MASK.

	* main.c (warning_1): Moved commas around.

Wed Oct 20 20:08:47 1993  Ian Searle  (ian@quixote)

	* list_node.c (listNode_SetScope): New function.
	(listNode_SetNum): New function.

	* list_node.h: Add two new fields. For scope checking, and
	list-node ordering.

Sun Oct 17 09:47:23 1993  Ian Searle  (ian@quixote)

	* toolbox/czt.r (czt): Improve default arg checking.

Sat Oct 16 13:57:54 1993  Ian Searle  (ian@quixote)

	* fi_1.c (matrix_Eig_GNEP): Use complex_div instead of
	complex_Div. This keeps AIX cc from puking when compiled with -O. 

Sat Oct  9 23:51:23 1993  Ian Searle  (ian@quixote)

	* rlib/isempty.r: Fixed, was backwards.

Sun Oct  3 22:36:51 1993  Ian Searle  (ian@quixote)

	* toolbox/fftplot.r (fftplot): Fix it so frequency scale is
	returned, and mag and ph are truncated.

Sat Oct  2 08:35:51 1993  Ian Searle  (ian@quixote)

	* main.c (main): Add some more command line options.

	* op_append.c (matrix_matrix_app): Changed matrix_Copy to
	matrix_copy_complex. 

	* code.c (function_default_return): Removed unused variable tmp.
	(bltin): Removed unused variable tmp.

	* matrix_op2.c (matrix_Pow2): Fix stupid bug. Using wrong MAT
	macro.

	* test: Added eigenvalue tests.

Fri Oct  1 23:36:17 1993  Ian Searle  (ian@quixote)

	* math_2.c (Eig): Finish up new eig() features.

Sun Sep 26 09:57:01 1993  Ian Searle  (ian@quixote)

	* fi_1.c (matrix_Eig_SEP): New function.

Sat Sep 25 16:22:34 1993  Ian Searle  (ian@quixote)

	* math_3.c (matrix_is_symm): New function.
	(Issymm): New function.

Wed Sep 22 21:40:29 1993  Ian Searle  (ian@quixote)

	* code.c (list_assign): Change numeric to string conversion to
	".6g". and fix lack of iCONSTANT in list_assign().

Tue Sep 14 18:52:03 1993  Ian Searle  (ian@quixote)

	* util.c (cpstr_strip): SIZE_T change.

	* r_string.c (string_Read): SIZE_T change.

	* mem.c (xrealloc): Changed all SIZE_T to size_t.

	* rlib/plot.r (plotm): Remove name() uses, replace with "?"
	temporarily. 

Sat Sep 11 11:17:52 1993  Ian Searle  (ian@quixote)

	* fi_2.c (matrix_Sylv_Complex): New function.

	* math_3.c (Sylv): New function.

	* fi_2.c (matrix_Sylv_Real): New function.
	(matrix_Sylv): New function.

Fri Sep 10 16:31:24 1993  Ian Searle  (ian@quixote)

	* complex.c (complex_gt): Change complex relationals back to
	original method (using magnitudes).

Thu Sep  9 21:37:57 1993  Ian Searle  (ian@quixote)

	* bltin.c (System): Remove name() function.
	(Matrix_cast): Fix string-matrix cast.
	(Scalar_cast): Fix string-scalar casts.
	(Show): Add string to type descriptor.

	* random.c (SRand): Add if(once) statement so that srand() can be
	called before rand().

Tue Sep  7 17:51:00 1993  Ian Searle  (ian@quixote)

	* matrix_op2.c (matrix_Pow1): Fix up [m].^salar ops.
	(matrix_is_positive): New function.

	* scalar_op1.c (scalar_Pow): Fix up powers (again).

Mon Sep  6 09:33:06 1993  Ian Searle  (ian@quixote)

	* math_2.c (Sort): Make string sort, a vector function.

	* op.c (ent_ent_add): Add matrix-string adds.

	* matrix_op2.c (matrix_string_add): New function.

	* r_string.c (string_add): New function.

Mon Aug 30 18:16:11 1993  Ian Searle  (ian@quixote)

	* scan.l: Ignore \f (form-feed control character.

	* rlab.y: Made a[], and a[;] allowable (they are no-ops).

Sun Aug 29 00:01:13 1993  Ian Searle  (ian@quixote)

	* math_3.c: Same as math_2.c.
	(FFT): Move position of tmp2 creation so that it occurs after
	matrix has been either trucated, or extended.
	(IFFT): Move position of tmp2 creation so that it occurs after
	matrix has been either trucated, or extended.

	* math_2.c: Use TARG_DESTROY macro in all functions where
	convert_to_matrix, or convert_to_scalar is used.

	* print.c (do_printf): Must check argcnt <= 0 since argcnt is
	unsigned. 

	* rlab.h: Removed some of the portability oriented defines, and
	put them in config.h

	* rlib/isinf.r (isinf): Check for -inf also.

	* rlib/linspace.r (linspace): Check N >= 2.

	* rlib/logspace.r (logspace): Check N >= 2.

	* rlib/triu.r (triu): use .nr, and .nc. Also check k correctly.

Sat Aug 28 12:12:33 1993  Ian Searle  (ian@quixote)

	* rlib/tril.r (tril): Use .nr, and .nc. Also check k correctly.

	* math_3.c (IFFT): Scale the result by 1/N (like MATLAB).
	(FFT): Remove the 1/N scaling (like MATLAB).
	(FFT): Make fft() behave like MATLAB, with 2nd argument.
	(IFFT): Make ifft() behave like MATLAB, with 2nd argument.

	* complex.c (complex_or): Make complex relational behave like
	MATLAB. 

	* main.c (init_environment): Check environment for PAGER if
	RLAB_PAGER is not specified.

Wed Aug 25 23:29:32 1993  Ian Searle  (ian@quixote)

	* rlab.y: Added f(,,3,,5) capability to function calls.

Tue Aug 24 22:41:42 1993  Ian Searle  (ian@quixote)

	* math_2.c (Sort): Make sort() handle scalar string.

Wed Aug 18 21:02:55 1993  Ian Searle  (ian@quixote)

	* matrix.c (matrix_AppendColC): Some cosmetic touch ups while
	looking for a mem-clobber.

Tue Aug 17 21:04:19 1993  Ian Searle  (ian@quixote)

	* fi_1.c (matrix_QrPR): Create [P] as a k-by-n.
	(matrix_QrPZ): Create [P] as a k-by-n.

	* matrix_op2.c (matrix_Rdivide): Make a / [] work.
	(matrix_Ldivide): Make a \ [] work.

	* matrix_op1.c (matrix_Add): Make a + [] work.
	(matrix_Sub): Make a - [] work.
	(matrix_El_Div): Make a ./ [] work.
	(matrix_El_Mul): Make a .* [] work.

Mon Aug 16 23:31:04 1993  Ian Searle  (ian@quixote)

	* fi_1.c (matrix_QrP): New function(s).

Sat Aug  7 08:30:44 1993  Ian Searle  (ian@quixote)

	* matrix_op2.c (matrix_ReadGeneric): Changed to MATLAB flat-file
	format. 
	(figure_it_out): New function.

	* op_matrix.c (matrix_vector_assign): Add code (move) to re-type
	empty matrices.
	(matrix_assign): Same.

	* matrix.c (matrix_AssignRow): Remove matrix rhs-lhs type
	matching, this should be done in op_matrix.c.
	(matrix_Assign): Same.
	(matrix_AssignCol): Same.
	(matrix_AssignVector): Same.

Wed Aug  4 19:36:20 1993  Ian Searle  (ian@quixote)

	* matrix.c (matrix_AssignCol): Change (1, 1) to (0, 0) is create
	matrix calls.

Mon Aug  2 19:41:27 1993  Ian Searle  (ian@quixote)

	*  (./rlib): complement.r, intersection.r, set.r, union.r, New
	function.s 

	* op_matrix.c (matrix_reshape_col): Make [:] work on scalar STRING
	entities. 

	* util.c (convert_all_to_matrix_d): New function.

Sun Aug  1 22:50:30 1993  Ian Searle  (ian@quixote)

	* bltin.c (Find): Make find() handle scalar input.

Fri Jul 30 22:35:33 1993  Ian Searle  (ian@quixote)

	* op_matrix.c (matrix_assign): Same changes as made to
	matrix_vector_assign(). 

	* matrix.c (matrix_AssignVector): Free old matrix string element
	before assigning new value.
	(matrix_Assign): Same as above.
	(matrix_AssignCol): Same as above.
	(matrix_AssignRow): Same as above.

	* op_matrix.c (matrix_vector_assign): Add code to treat strings
	like scalar numerics.

	* op.c (ent_ent_el_pow): Add defaults to the switches to catch
	non-numeric entities.

Thu Jul 29 18:23:53 1993  Ian Searle  (ian@quixote)

	* toolbox/lagrange.r: Added check for out-of-bounds.

	* matrix.c (matrix_AppendRowS): Copy the null string into the
	empty matrix elements.

Wed Jul 28 23:33:15 1993  Ian Searle  (ian@quixote)

	* scalar_op1.c (scalar_Pow): Fix BOZO in 2nd comparison test.

Tue Jul 27 06:13:19 1993  Ian Searle  (ian@quixote)

	* main.c (run_program): Check ijmp so that we don't run out of
	longjmps in the non-interactive case.

Sun Jul 25 20:03:21 1993  Ian Searle  (ian@quixote)

	* rfile.c (find_open): closedir before we call run_program in case
	an error occurs.

	* rlab.y (ryyerror): Add longjmp call to ryyerror, also function
	scope resetting.

	* main.c (run_program): Now when an error occurs, keep
	longjmp()'ing up until we hit input == 0.

	* code.c (function_define): Made to small, but significant
	changes.  `function_SetCodeSize (u_func, psize + 4);' the number 4
	was a 5. And, `for (i = psave; i < psize + psave; i++)' the `<'
	used to be a `<='. These changes were made simply because we were
	using an extra piece of code when copying the function, which may
	not be safe under some rare circumstances. This bug popped up when
	I installed fvscope().

Sat Jul 24 09:17:10 1993  Ian Searle  (ian@quixote)

	* dissassem.c (diss_assemble): Fixed bug in OP_LIST_MEMB, and
	OP_LIST_CREATE dissasembly.

Fri Jul 23 21:51:33 1993  Ian Searle  (ian@quixote)

	* bltin.c (FVScope): New function.

Wed Jul 21 20:05:45 1993  Ian Searle  (ian@quixote)

	* op_matrix.c (matrix_stack): Make [a;s] work, when a in
	numeric-string. 

	* op_append.c (matrix_string_app): Make [a,s] work, where a is
	numeric-empty. 

Tue Jul 20 08:22:34 1993  Ian Searle  (ian@quixote)

	* matrix.c (matrix_AssignVector): Add logic so that we can have
	any RHS when assigning to an empty matrix.
	(matrix_AssignRow): Same as previous change.
	(matrix_AssignCol): Same as previous change.
	(matrix_Assign): Same as previous change.

	* rlib/input.r: New function.

	* toolbox/mret.r: New function.

Sun Jul 18 09:03:16 1993  Ian Searle  (ian@quixote)

	* code.c (reset_stack_ptr): New function.

	* main.c (run_program): Call reset_stack_ptr after longjmp().

	* rlib/input.r (input): New function.

	* matrix.c (matrix_print_real): Modify matrix print format.

	* bltin.c (Clear): Improved error messages.

Sat Jul 17 08:08:31 1993  Ian Searle  (ian@quixote)

	* rlib/num2str.r (num2str): New function rfile.

	* code.c (find_lineno): Check for NULL ptr if we get an error, or
	warning on the very 1st statement.

Wed Jul 14 20:31:18 1993  Ian Searle  (ian@quixote)

	* rlib/redit.r: Removed file existence test.

Tue Jul 13 20:40:01 1993  Ian Searle  (ian@quixote)

	* main.c (run_program): Add call to reset_frame_ptr to set fp back
	after a longjmp.

	* code.c (reset_frame_ptr): New Function.

Mon Jul 12 18:49:33 1993  Ian Searle  (ian@quixote)

	* Release v0.91b.

	* Major changes to rlab.y, scan.l. to make the parser generate
	codes, line at a time.

Wed Jul  7 22:02:33 1993  Ian Searle  (ian@quixote)

	* rlib/tmp_file.r: Use static variable to help insure uniqness.

Mon Jul  5 00:40:17 1993  Ian Searle  (ian@quixote)

	*  (./rlab): Release v0.90a.

	* bltin.c (Load): Added close_file_ds() call. This is overkill,
	but what the heck (safety 1st).

	* util.c (btree_get_node_names_who): Don't print variable names
	that begin with a "_".

	* rlab.y: Removed pure parser declaration.

	* scan.l: Went back to classical lex-yacc interaction (not a
	pure-parser). 

	* dissassem.c (diss_assemble): Update for new op-codes.

Sun Jul  4 20:12:31 1993  Ian Searle  (ian@quixote)

	* code.c (execute): Add OP_RFILE, OP_RFILE_NAME codes.

	* Have made major changes to main.c, code.[ch], bltin.c to make
	the parser/machine callable while executing code.

Thu Jul  1 21:31:02 1993  Ian Searle  (ian@quixote)

	* btree.c (btree_write_nodes): Check for BLTIN, and UFUNCTION.

	* rfile.c (rfile_load): Print out full file name in error message.

	* matrix.c (matrix_ExtractRowMatrix): Cast element references when
	bounds checking, so that NaNs and Infs are properly handled.

Fri Jun 25 17:30:48 1993  Ian Searle  (ian@quixote)

	* test (S): Added sprintf() test.

Thu Jun 24 20:15:35 1993  Ian Searle  (ian@quixote)

	* print.c (do_printf): Fix up argument handling for formats with
	width and/or precision specifiers.

Wed Jun 23 19:33:26 1993  Ian Searle  (ian@quixote)

	* scalar_op1.c (scalar_Pow): Use complex computation all the time.
	(scalar_Pow): Always return 1 when s2 is 0.

Tue Jun 22 16:26:58 1993  Ian Searle  (ian@quixote)

	* config/*: Added HAVE_TIME_H define.

	* config/config.svr4:  Added HAVE_STDLIB_H define.

	* scan.l: Get rid of #elif pre-processor statements (not K&R
	compatible). 

	* rlab.h:   Added HAVE_STDLIB_H block.

	* config/config.rs6000: Added HAVE_STDLIB_H define.

	* rfile.c:  Added HAVE_STDLIB_H block.

	* symbol.c: Added HAVE_STDLIB_H block.

	* matrix.c: Don't need stdlib.h include anymore.

	* config/config.hpux: Got access to an HP 9000/720, HP-UX 8.05.
	This config files has now been tested.

	* fi_1.c (matrix_Svd_Complex): Added "A", "S" abililty.

	* math_2.c (Svd): Added "S", "A", 2nd arg to svd() list.

	* bltin.c (Zero): Cast matrix_Create args to (int).
	(Ones): Cast matrix_Create args to (int).

Sat Jun 19 22:25:10 1993  Ian Searle  (ian@quixote)

	* init.c (rlab_bltin): Add _garbage function.

	* README.install: Update installation instructions for make
	install. 

	* Makefile (mkdir): Remove `rm' command from Makefile.

	* rlib/whos.r (whos): Calculate nbytes correctly for complex
	types. 

	* util.c (btree_get_node_names_what): Don't print builtin
	functions that begin with a `_'.

	* scan.l: Allow variable names that begin with a `_'.

Mon Jun 14 19:48:17 1993  Ian Searle  (ian@quixote)

	* toolbox/pinv.r (pinv): Fixed bug in tol calc.

Mon Jun  7 19:13:25 1993  Ian Searle  (ian@quixote)

	* Makefile (COPYDIR): Copy doc directory and config.h file during
	install. 

	* config/config.sun4: Add ifdef __GNUC__ to handle sys/ieeefp.h,
	and float.h

	* matrix_op2.c (matrix_gt_zero): Fix error message.

Sun Jun  6 09:10:12 1993  Ian Searle  (ian@quixote)

	* rlib/diff.r (diff): Finished appr. comments.

Sat Jun  5 19:14:07 1993  Ian Searle  (ian@quixote)

	* matrix_op2.c (matrix_scalar_Pow1): Fix op for exp <= 0.

	* fi_2.c (matrix_Schur): New function.

Wed Jun  2 23:08:04 1993  Ian Searle  (ian@quixote)

	*  Release Version 0.83 beta.

Mon May 31 17:40:45 1993  Ian Searle  (ian@quixote)

	* code.c (forcode): Fix scalar execution of loop.
	(forcode): Set limit properly when vec_expr is a scalar.

Sun May 30 09:22:34 1993  Ian Searle  (ian@quixote)

	* rlab.h: Added NUM type.

	* bltin.c (get_bltin_arg): Added NUM type

	* random.c (Rand): Use get_num_scalar_val more to reduce gc
	inefficiency. 

	* Release v0.82

Sat May 29 22:55:06 1993  Ian Searle  (ian@quixote)

	* rlib/plot.r: Added showterm(), setterm(), phrd().

	* scan.l: Changed NUMBER regexps so that `a.e1' (list member ref)
	won't ge confused with exponential form of NUMBER.

Wed May 26 17:52:16 1993  Ian Searle  (ian@quixote)

	* scan.l (rlab_yy_input): Signal() should be called with
	intcatch_wait as arg.

	* btree.c (btree_copy_nodes): Add UNDEF case.

Mon May 24 20:23:49 1993  Ian Searle  (ian@quixote)

	* removed testmatrices directory.

	* ode*: Mods to user-output capabilities.

Sun May 23 13:50:21 1993  Ian Searle  (ian@quixote)

	* toolbox/FFT2.r: New file.

	* toolbox/FFT.r: New file.

	* toolbox/hankel: New rfile.

	* toolbox/ode78.r: Added Uoutput.

	* rlib/ode23.r: Added Uoutput.

	* op_matrix.c (matrix_reshape_col): Try and make more efficient if
	input is already a column. 

	* matrix_op1.c (matrix_ne): Fix goof in REAL !+ COMPLEX, and
	COMPLEX != REAL.

Wed May 19 18:19:00 1993  Ian Searle  (ian@quixote)

	* bltin.c, btree.c: Add UNDEF case to write() options. 

Sat May 15 12:25:25 1993  Ian Searle  (ian@quixote)

	* code.c (ret_from_func): Use btree_FindNodeR.

	* btree.[ch] (btree_FindNodeR): New function.

	* test: Added lqr test to test-suite.

	* Makefile: Added install for rlab.1 (man-page).

	* Makefile: Clean LIBDIR before installing files.

	* scan.l: Use strtod() more often (replace sscanf()).

Fri May 14 21:46:25 1993  Ian Searle  (ian@quixote)

	* toolbox/*.r, rlib/*.r: Any files that neede class() or type()
	mods. 

	* code.c (list_member): Change type member results for
	consistency. 

	* btree.[ch] (btree_GetRealNumNodes): New function.

	* bltin.c (Type): More consistemcy changes.

	* bltin.c (Class): More consistemcy changes.

	* bltin.c (Show): Working on consistency.

	* main.c (warning_?): Check for s being an arg tag, print null
	string if so. 

Sun May  9 10:56:13 1993  Ian Searle  (ian@quixote)

	* examples/testmatrices/jordan.r: Removed "dummy" usage.

	* examples/testmatrices/krylov.r: Removed "dummy" usage.

	* examples/testmatrices/jordan.r: Removed "dummy" usage.

	* examples/testmatrices/cauchy.r: Removed "dummy" usage.

	* bltin.c (Ones, Zero): Onnly accept matrices with m*n == 2.

	* toolbox/rk4.r: Changes function names to match file name, fixed
	bug in calling rrk4(), y-argument.

	* code.c (assign): Don't check for "-" when assigning anymore. Not
	necessary cause there are always ENTITIES in function arg lists.

	* code.c (function_call): Don't label UNDEF args "dummy".

	* code.c (ret_from_func): Don't test args for key == 0 on clean. 

	* rlib/triu.r, tril.r: Remove "dummy" usage.

	* rlib/linspace.r: Remove "dummy" usage.

	* contrib/FFT.r, FFT2.r, hankel.r, toepltiz.r: Remove "dummy"
	usage. 

	* code.c (print): Check for BLTIN.

	* rlib/whos: Add check for arg exist.

	* rlib/ode23: Remove "dummy" usage, add checks

	* rlib/plot.r: Check N in plot()

	* rlib/redit.r: Remove "dummy" usage.

	* rlib/redit.r: Remove "dummy" usage.

	* rlib/pause.r: Remove "dummy" usage.

	* rlib/eye.r: Remove "dummy" usage.

	* rlib/diff.r: Remove "dummy" usage.

	* toolboz/ode78.r: Remove "dummy" usage.

	* toolbox/lagrange.r: Remove "dummy" usage.

	* toolbox/chop.r: Remove "dummy" usage.

	* toolbox/bandred.r: Remove "dummy" usage.

	* code.c (function_call): Push UNDEF on for non-existent args.

Sat May  8 11:19:30 1993  Ian Searle  (ian@quixote)

	* rlib/lu.r: New file, replaces old lu() built-in

	* /help/backsub: New file

	* help/factor: New file

	* fi_1.[ch]: Removed matrix_LU().

	* fi_2.c (matrix_Backsub): Added error checking

Thu May  6 22:51:34 1993  Ian Searle  (ian@quixote)

	* fi_2.c (matrix_Factor): new function.

	* fi_2.c (matrix_Backsub): New function

Tue May  4 19:31:38 1993  Ian Searle  (ian@quixote)

	* toolbox/erf.r: Added erfcc(). Mods to inverf().

	* main.c (rpclose): New function.

	* code.c (print): Mods to use `use_pager' flag when printing
	matrices. 

Mon May  3 21:37:21 1993  Ian Searle  (ian@quixote)

	* code.c (print): Add rule-of-thumb, to avoid using popen() so
	much. 

Sun May  2 13:14:39 1993  Ian Searle  (ian@quixote)

	* code.c (ret_from_func): fix screw-up in local list clean.

	* rlib/plot.r: Re-written.

	* toolbox/gamma.r: Mods, uses static, updates to any(), all()
	usage. Also fixed gamm[pq] arg blunder.

Sat May  1 16:53:17 1993  Ian Searle  (ian@quixote)

	* print.c (FPrintf): Check fp for NULL.

Fri Apr 30 23:27:11 1993  Ian Searle  (ian@quixote)

	* print.c (do_printf): Add check for strv == 0.

Thu Apr 29 18:16:10 1993  Ian Searle  (ian@quixote)

	* code.c (ret_from_func): Test rd.u.ent for NULL name ptr.

Wed Apr 28 19:04:21 1993  Ian Searle  (ian@quixote)

	* op_matrix.c (matrix_vec_assign): Mods to handle scalars at top. 

	* code.c (ret_from_fun): Handle local lists now.

	* op_matrix.c (matrix_assign): Mods to handle scalars at top.

Tue Apr 27 21:25:59 1993  Ian Searle  (ian@quixote)

	* rlib/ode23.r: More efficient, use a LIST inside ode23(), then
	use collapse() to return a matrix.

	* bltin.c (Diag): New function.

	* bltin.c (Ones): New function.

Sun Apr 25 11:17:09 1993  Ian Searle  (ian@quixote)

	* code.c (ret_from_func): Do not clean BTREE objects from local
	variable list.

	* matrix_op1.c (matrix_eq and related functions): Add ability to
	do strinf-matrix ops when one matrix is a 1-by-1.

	* relation.c: All functions. Use switch, additions for
	matrix-string rel-ops.

	* matrix_op2.c: New functions... matrix_string_??().

	* code.c (execute): in OP_POP_CLEAN, add test for non-null entity
	type. 

	* matrix_op1.c (matrix_Multiply??): Add check for either A or B
	being an empty matrix, return an empty matrix.

	* util.c (convert_all_to_matrix): Changed d to new in
	string-matrix convert.

Sat Apr 24 11:22:56 1993  Ian Searle  (ian@quixote)

	* btree.c (btree_Print): Print <<>> for empty-list, even when list
	has UNDEFs.

	* bltin.c (Exist): New function

	* rlib/plot.r: Make pinfo static.

Fri Apr 23 23:38:39 1993  Ian Searle  (ian@quixote)

	* rlab.y, scan.l, main.c: Started addition of fstatic()
	declaration. 

Wed Apr 21 19:29:08 1993  Ian Searle  (ian@quixote)

	* code.c (find_file_name): Go straight to file name since we know
	exactly where it is.

Tue Apr 20 16:47:34 1993  Ian Searle  (ian@quixote)

	* code.c (forcode): This is really where yesterday's list-bug was
	lurking. The problem was not installing tmp for-vectors on the
	tmp-list. 

Mon Apr 19 19:38:39 1993  Ian Searle  (ian@quixote)

	* r_string.c (string_Read): Use fscanf() instead of getc() to get
	the last \n. This seems to work ?.

	* list.c (list_DetachNodeByAddr): Added check for n == 0. This may
	happen in some rare cases when the list is really clean.

	* code.c (ifcode, whilecode): Handle empty matrices as if(),
	while() args (eval to 0).

	* bltin.c (Read): Try and print out type if failure.

	* rlib/sign.r: Removed scalar option.

	* rlib/fix.r: New file

	* config/config.linux: Updated file from F.F.Yap.

Sun Apr 18 12:16:05 1993  Ian Searle  (ian@quixote)

	* Release version 0.75 beta

	* rlib/ode23.r: Mods to make ode23() operate on column solutions,
	and independent of y0 orientation.

	* toolbox/ode78.r: New function (from netlib).

Sat Apr 17 09:27:52 1993  Ian Searle  (ian@quixote)

	* toolbox/poly.r: Updated all() usage.

	* rlab.y: Moved function assign production to statement level so
	that trailing newline, or semicolon can be left out.

	* test: Incorporated getline() tests into test.

Thu Apr 15 19:46:57 1993  Ian Searle  (ian@quixote)

	* getline.c: Overhauled getline_scanner(), collect_decinal(), and
	collect_string() so that getline() will handle EOF.

Wed Apr 14 20:35:08 1993  Ian Searle  (ian@quixote)

	* test: Added a few more simple function tests.

Mon Apr 12 18:58:01 1993  Ian Searle  (ian@quixote)

	* util.c (convert_to_matrix): Removed call to remove_tmp_detroy(),
	to fix chol(1+1i) core dump.

Sun Apr 11 10:21:28 1993  Ian Searle  (ian@quixote)

	* rlib/cum[sum|prod].r: Re-write per Brad's suggestion (more
	efficient). 

	* init.c: Ordered bltin table for faster lookup.

	* util.[ch] (convert_all_to_matrix): New function.

	* op_matrix.c (matrix_vector_sub): Allow s[1] to work for a scalar
	string. 

	* bltin.c (Size, Length): Change the way we report on strings.

	* code.c (list_member): Add n, nr, nc as string attributes.

Sat Apr 10 10:46:00 1993  Ian Searle  (ian@quixote)

	* config.*: Fixed up obsolete comments around #include <float.h>

	* fi_1.c (matrix_inverse_?): Add call to matrix_Rcond() to check
	for ill-conditioned input.

Sun Apr  4 15:02:21 1993  Ian Searle  (ian@quixote)

	* fi_1.c (matrix_is_symmetric): Removed.

Sat Apr  3 00:05:57 1993  Ian Searle  (ian@quixote)

	* r_string.c (string_Read): Handle zero length string, and newline
	correctly. 

	* code.c (assign): Fix bungle in assign symbol table.

	* Copied bandred from testmatrices to toolbox.

	* Added contrib directory.

	* print.c (Close): Change test from `== 0' to `!= 1'.

	* test: Added tests for some of the more basic builtin functions
	(abs, max, sum, floor,...).

	* matrix_op1.c (matrix_Abs): Add #define rabs...

	* util.c (get_num_scalar_val): Put break where appropriate.

Fri Apr  2 20:50:05 1993  Ian Searle  (ian@quixote)

	* Many changes to get **return_ptr correct.

	* many small changes to get gcc -Wall  to shut up.

	* rfile.c (print_rfiles): Add extra space, and fflush() to force
	popen'ed ptr to behave correctly.

	* fi_1.c, matrix.c: Put #define rabs in.

	* util.c (btree_get_node_names): return a row matrix.

	* rlab.y, scan.l, symbol.[ch], util.c: Added $$ as globla symbol
	table constant.

Thu Apr  1 18:44:55 1993  Ian Searle  (ian@quixote)

	* Changed many error_1 messages, `wrong #' to Wrong number'.

	* main.c (warning_?): Fixed fprintf FILE ptr arg.

Wed Mar 31 19:24:13 1993  Ian Searle  (ian@quixote)

	* bltin.c (Length): Make compatible (partly) with Matlab.

	* alloca.c: Add #ifndef __GNUC__ to elminate supplied alloca if
	gcc is being used.

	* config/config.NeXT: Uncomment HAVE_PROTOTYPES, remove
	declarations at end of file.

Tue Mar 30 23:26:35 1993  Ian Searle  (ian@quixote)

	* code.c (list_el_create): Allow U_FUNCTION as valid type in
	switch. 

Sun Mar 28 11:24:02 1993  Ian Searle  (ian@quixote)

	* matrix_op1.c (matrix_El_Div): use matrix_screen_string().

	* bltin.c (CD): New function.

	* op_matrix.c (matrix_create): fix [2i], initialize real part.

	* toolbox/redit.r: New rfile.

	* scan.l: Take lineno++ out of # comment rule.

Sat Mar 27 09:27:01 1993  Ian Searle  (ian@quixote)

	* Now release v0.70.

	* op_matrix.c (matrix_stack): Fix type checking error in [1+2i;2]
	operation. 

Fri Mar 26 23:00:34 1993  Ian Searle  (ian@quixote)

	* Version 0.70 beta released.

	* scan.l: Added `#' as a commnet, now we can `#!/bin/rlab' our
	scripts. 

Wed Mar 24 00:02:06 1993  Ian Searle  (ian@quixote)

	* code.c (list_member): Make attribute look-up more consistent. 

	* bltin.c (Length): New function.

	* math_2.c (Sort): Make sort() a vector function.

Tue Mar 23 21:02:01 1993  Ian Searle  (ian@quixote)

	* matrix_op1.c (matrix_Any, matrix_All): Change to vector
	functions. 

	* util.c (get_datum_value): Fixed bug in extracting from 1-by-1.

	* matrix_op1.c: Most of the matrix relational functions. Added
	ability to recognize 1-by-1 matrices, and perform correct check.

Mon Mar 22 10:55:43 1993  Ian Searle  (ian@quixote)

	* rlab.y: Added production to opt_arg_list:

          | ',' error              { $$.count = 0; $$.off = 0; }

          The purpose of this rule is to prevent `sqrt ( , 2 )' from being
	  a valid expression.

Sun Mar 21 23:02:59 1993  Ian Searle  (ian@quixote)

	* matrix_op2.c (matrix_Rdivide): Special case 1x1.

Sat Mar 20 14:36:19 1993  Ian Searle  (ian@quixote)

	* scan.l, rlab.y, code.[ch], dissasem.c, matrix_op1.[ch]: Added
	non-conjugate matrix transpose (.')

	* op.c (ent_ent_el_ldivide): Fixed typo in argument order.

	* op.c (rdivide, ldivide): Force all entities to be matrices, let
	low-level function determine appropriatness of dimensions.

Wed Mar 17 19:28:13 1993  Ian Searle  (ian@quixote)

	* btree.c (btree_Print): Change empty list printf().

Tue Mar 16 00:18:05 1993  Ian Searle  (ian@quixote)

	* matrix_op1.c (matrix_scalar_div2): Fix so 2./(1:3) works.

	* matrix_op1.c: Changes to handle [A] binop [3] conditions.

Mon Mar 15 20:56:18 1993  Ian Searle  (ian@quixote)

	* util.c (get_datum_value): Fix it so the function returns the
	value from a 1x1 matrix.

	* matrix_op2.[ch] (max, min): Modified max(), min() functions to
	behave more like MATLAB counterparts.

	* bltin.c (Reshape): mods to get rid of convert_to_scalar calls.

	* bltin.c (Scalar_cast, Matrix_cast): modified logix to get rid of
	convert_to_scalar().

	* print.c (SPrintf): Make sprintf() create the 1st argument if it
	is UNDEFINED.

	* math_1.c: Added

	  if (targ.u.ent != arg.u.ent)
	    remove_tmp_destroy (targ.u.ent);
	  return;

	  To all clean up temporary Datums when using convert_to_scalar.


Sun Mar 14 10:10:04 1993  Ian Searle  (ian@quixote)

	* scalar_op1.[ch], matrix_op1.[ch], complex.[ch], trig.c: add
	complex arc-trig functions.

	* scalar_op1.[ch], complex.[ch], trig.c, matrix_op1.[ch]: Add
	complex tangent.

	* rlab.y, code.[ch], dissamsem.c: Add `[:]' operation.

Sat Mar 13 12:34:46 1993  Ian Searle  (ian@quixote)

	* math_3.c (FFT): Add matrix fft capability.

Fri Mar 12 19:05:19 1993  Ian Searle  (ian@quixote)

	* op_matrix.c (matrix_transpose): Fix scalar complex transpose.

	* code.c (forcode): Add complex loop capability.

	* math_2.c (Chol, Det): Make them accept scalars as arguments.

	* math_2.c (Balance, Rcond): Make them accept scalars as arguments.

	* matrix.c (matrix_Print*): Add format for empty matrices.

Thu Mar 11 20:46:11 1993  Ian Searle  (ian@quixote)

	* math_1.c (Lu): Mods to handle scalar args.

	* eye.r: Mods to deal with new zeros().

	* bltin.c (Zero): Mods to allow it too handle combinations of
	matrices, and scalars.

	* rlab.y (yyparse): Small twiddle to newline production.

Tue Mar  9 19:49:06 1993  Ian Searle  (ian@quixote)

	* code.[ch], rlab.y, dissasem.c: Add OP_EMPTY_MATRIX_CREATE.

	* matrix.c (extraction functions): Small changes to extraction
	functions to handle NULL index matrices.

	* matrix_op2.c (matrix_Find): Fix logic around realloc() to avoid
	calling realloc with a zero argument.

Mon Mar  8 19:52:17 1993  Ian Searle  (ian@quixote)

	* op_matrix.c (matrix_sub): Make double indexing error checking
	behave like single indexing error-checking.

	* code.c (function_call): Convert CONSTANT args to scalars. 

	* matrix_op2.c (matrix_Find): Check for empty matrix when
	realloc'ing. 

	* matrix_op2.c (Prod): Fix complex products.

Sat Mar  6 11:31:50 1993  Ian Searle  (ian@quixote)

	* matrix.c (matrix_Write): Increased number of significant digits
	for output.

	* fi_[12].c: Remove the dependencies on f2c.h.

Fri Mar  5 17:16:41 1993  Ian Searle  (ian@quixote)

	* bltin.c (Show): Check for NULL names.

Sun Feb 28 10:25:53 1993  Ian Searle  (ian@quixote)

	* code.c (list_member): Made SCALAR attributes cosistent with
	MATRIX attributes.

	* matrix_op2.c (matrix_scalar_Pow): New function.

	* version.h: Changed version string. I am makeing the switch to
	BETA status.

	* matrix_op2.c (matrix_Max/matrix_Min): Small changes to
	algorithms. 

Thu Feb 25 20:26:41 1993  Ian Searle  (ian@quixote)

	* matrix.[ch]: matrix_ExtractElement, matrix_ExtractColumn,
	matrix_ExtractRow: new functions.

	* op_matrix.c (matrix_sub): Modify function loginc to improve
	speed. 

Tue Feb 23 21:11:34 1993  Ian Searle  (ian@quixote)

	* Incorporated config.NeXT, and NeXT patches.

Mon Feb 22 20:10:56 1993  Ian Searle  (ian@quixote)

	* math_2.c (Sort): Finished adding sort() features, complex,
	scalars, etc...

Sun Feb 21 15:46:49 1993  Ian Searle  (ian@quixote)

	* main.c, code.c, rlab.h, fi_[12].c: Changed way we catch SIGINT.

	* math_3.c, matrix_op2.[ch]: Added builtin versions of sum(),
	prod().

Tue Feb 16 21:21:59 1993  Ian Searle  (ian@quixote)

	* scalar.c (scalar_Create): Mods for small speedup.

	* list_node.[ch] (listNode_IsNodeAttached): Replace function with
	a macro in an attempt to speed things up.

Mon Feb 15 20:55:30 1993  Ian Searle  (ian@quixote)

	* test: Added matrix multiply tests.

	* matrix_op1.c (matrix_Mul??): Mods to handle A or B 1x1.

	* mm.c (ccmpy): Modified for a little more speed (courtesy Fook
	Fah). 

Sat Feb 13 21:00:48 1993  Ian Searle  (ian@quixote)

	* mm.c: New file.

	* matrix_op1.c (matrix_Mul??): Use contributed C matrix multiply
	code (faster).

Fri Feb 12 23:26:11 1993  Ian Searle  (ian@quixote)

	* code.c (list_member): Add member refs for CONSTANTs.

	* code.c (list_member): Add `.n' as scalar member.

Tue Feb  9 17:56:25 1993  Ian Searle  (ian@quixote)

	* math_2.c (MaxI/MinI): maxi()/mini() now return a scalar index
	value. 

Mon Feb  8 18:34:55 1993  Ian Searle  (ian@quixote)

	* code.c (forcode): Yet another change. Now for() will handle
	CONSTANTs were there should be vectors, without barfing.

	* math_2.c (Sort): sort() now returns a list of the sorted vector,
	and the sorted indices.

	* code.c (list_create): Remove erroneous call to
	convert_to_scalar().

	* matrix.c (matrix_assign_vector): Add calls to matrix_Extend() to
	handle empty matrix RHS.

	* code.c (forcode): Now for-loops will handle user changing loop
	vector in the middle of loop execution.

Sun Feb  7 22:32:58 1993  Ian Searle  (ian@quixote)

	* math_1.c (Inv): Allow scalars as well as matrices.

	* code.c (forcode): Fixed STUPID bug in loop-vector destroy logic
	(there was none).

Sat Feb  6 11:07:32 1993  Ian Searle  (ian@quixote)

	* matrix_op2.c (matrix_[LR]divide): Add test to use solve_eq()
	when A is square.

	* matrix.c (matrix_CreateFill): Add empty vector creation
	capability. 

	* code.c (forcode): Add no-execute capability/test.

Fri Feb  5 19:03:45 1993  Ian Searle  (ian@quixote)

	* rlab.y, scan.l: Made rfile, and help commands more versatile.

	* math_2.c (MinI): Fix subscripts on m.

	* matrix_op2.c (matrix_Max): Fixed complex max(). maxc.r = 0.0,
	NOT maxc.r = -DBL_MAX. Same for matrix_Min().

Tue Feb  2 21:41:37 1993  Ian Searle  (ian@quixote)

	* matrix.c (matrix_CreateFill): Change d = ... use abs(d3).

Mon Feb  1 23:21:31 1993  Ian Searle  (ian@quixote)

	* matrix_op2.c (matrix_Mod): Added complex matrices.

	* math_1.c (Mod): Better type checking. Handles complex args now.

	* complex.[ch] (complex_Mod): new function.

Sun Jan 31 13:20:11 1993  Ian Searle  (ian@quixote)

	* matrix_op2.c (matrix_Mod): Add some error/type checking.

Fri Jan 29 23:48:42 1993  Ian Searle  (ian@quixote)

	* Makefile: Still trying to make friendlier.

Thu Jan 28 17:31:22 1993  Ian Searle  (ian@quixote)

	* matrix_op2.[ch] (matrix_Mod): New function.

	* matrix.c (matrix_print_complex): Fix sign in sprintf().

	* code.c (assign): Change "-1" to "-" for strncmp.

Wed Jan 27 22:27:02 1993  Ian Searle  (ian@quixote)

	* bltin.c (Size): try returning size = 1x1 for SCALAR.

Tue Jan 26 20:03:52 1993  Ian Searle  (ian@quixote)

	* main.c, rlab.y: Mods to error printing. Leave filename, line
	number off when reading from stdin.

Mon Jan 25 22:40:06 1993  Ian Searle  (ian@quixote)

	* version.h: New file.

	* bltin.c, matrix_op2.[ch]: Moved matrix_Find() to matrix_op2.c.

	* getline.c, print.c, scan.h: Moved scancode[][ into getline.c

Fri Jan 22 00:10:52 1993  Ian Searle  (ian@quixote)

	* rlab.y: Starting on if statement syntax rework.

	* bltin.c (Find): New function.

	* main.c (warning_?): Check (s == 0).

Sun Jan 17 12:37:11 1993  Ian Searle  (ian@quixote)

	* bltin.c (All): Make scalar args allowable.

	* bltin.c (Any): Make scalar args allowable.

	* scan.l (new_file): Made minor change so tha ctrl-d (EOF) now
	stops execution.

Fri Jan 15 19:55:57 1993  Ian Searle  (ian@quixote)

	* dissasem.c: Changed output formats.

	* main.c, rlab.y: Add line_nos.

Thu Jan 14 18:19:26 1993  Ian Searle  (ian@quixote)

	* code.c (function_default_ret): A few more touches on argument
	cleaning. 

Wed Jan 13 19:27:36 1993  Ian Searle  (ian@quixote)

	* code.c (ret_from_func): Finally got garbage-collection for
	function args right (I hope :-).

Sun Jan 10 15:14:12 1993  Ian Searle  (ian@quixote)

	* code.c (list_member): Add "type" to string elements.

Fri Jan  8 22:09:53 1993  Ian Searle  (ian@quixote)

	* scan.l (new_file): Twiddle with lineno to get it right AFTER a
	load(), or rfile command.

Wed Jan  6 21:59:50 1993  Ian Searle  (ian@quixote)

	* code.c, rlab.y (list_assign): Fix it so that `a.[i] = a'. Caused
	a chang in generated op-codes in rlab.y.

Tue Jan  5 22:50:47 1993  Ian Searle  (ian@quixote)

	* random.c (Rand): Fixed rand(m,n).

Sat Jan  2 18:23:59 1993  Ian Searle  (ian@quixote)

	* rlab.y: mods to STRING ptr handling.

	* main.c: Add ip option. Use cat(1) as pager if -p is specified. 

Fri Jan  1 11:49:53 1993  Ian Searle  (ian@quixote)

	* getline.c (getline_scanner): Added quoted string scanning
	capability. 

	* print.c (get_file_ds): Use mode argument in popen() call.

Thu Dec 31 16:20:11 1992  Ian Searle  (ian@quixote)

	* getline.c: New File

	* scan.h: New File

Wed Dec 30 14:42:06 1992  Ian Searle  (ian@quixote)

	* matrix_op2.[ch]: Changed matrix_ReadColumn() to
	matrix_ReadGeneric(), added matrix_WriteGeneric().

	* bltin.c: Changed ReadV() to ReadM(). Added WriteM().

Tue Dec 29 09:30:53 1992  Ian Searle  (ian@quixote)

	* rfile.c: set pfile = 0 after successful pclose().

	* code.c (print): Set pfile = 0 after succesful pclose().

Wed Dec 23 16:56:11 1992  Ian Searle  (ian@quixote)

	* print.c (rfile_Destroy): Fixed braces on outside if.

Sat Dec 19 21:00:28 1992  Ian Searle  (ian@quixote)

	* print.c (do_printf): Changed error messages, and added another
	argcnt check.

Sun Dec 13 14:09:37 1992  Ian Searle  (ian@quixote)

	* matrix.c (matrix_Read): Fix complex read indexing
	(NWRITE+start-1). 

	* matrix.c (matrix_write_real): Fix `columns X through Y' output. 

	* math_2.c (Eig): Add calls to matrix_SetName().

	* lots!: Changed copy_string_ptr() to cpstr().

Thu Dec 10 19:23:42 1992  Ian Searle  (ian@quixote)

	* code.c (print): Print to stdout if popen() fails.

	* bltin.c (Read): close file after reading

	* matrix.c (matrix_Read): Fixe for-test while scanf'ing.

Sun Dec  6 13:00:50 1992  Ian Searle  (ian@quixote)

	* main.c (pipecatch): New function.

	* rfile.c: Make FILE *pfile static so we can pclose() if SIGPIPE
	occured. 

	* code.c (print): Use popen() for matrix output.

	* main.c (run): Catch SIGPIPE.

Fri Dec  4 17:27:08 1992  Ian Searle  (ian@quixote)

	* rfile.c (print_rfiles): Test for nfile == 0.

Thu Dec  3 19:57:50 1992  Ian Searle  (ian@quixote)

	* main.c (main): Add -l option.

	* main.c: Remove RLAB_LS_CMD.

Wed Dec  2 18:19:27 1992  Ian Searle  (ian@quixote)

	* Put power-op higher in precedence than unary-minus

Mon Nov 30 20:11:14 1992  Ian Searle  (ian@quixote)

	* math_2.c (Sort): Added string sort.

	* rfile.c: Finish up, still crude, but functionality is there.

Sun Nov 29 22:08:09 1992  Ian Searle  (ian@quixote)

	* rfiile.c (help): Moved help functionality to rfile.c

Sat Nov 28 21:10:43 1992  Ian Searle  (ian@quixote)

	* rlab.y: Move HELP, and RFILE productions up to program:

	* rfile.c: New file.

Mon Nov 23 23:16:39 1992  Ian Searle  (ian@quixote)

	* rlab.y: Clean-ups, comments.

Sun Nov 22 10:26:00 1992  Ian Searle  (ian@quixote)

	* Released v0.30.

	* Fixed goof in rlab.y ( parens around vec_expr ).

	* mathl.c: New file

	* rlab.y: Added '(' vec_expr ')' to vec_expr: rule.

	* mem.c (xmalloc, xrealloc): New functions. Now (hopefully) people
	can use most any compiler, and the provided alloca.c, and not get
	unresolved externals.

	* matrix.c (matrix_print_real): Use sprintf() now.

	* math_1.c (Round) New function, uses math library rint().

Sat Nov 21 22:13:34 1992  Ian Searle  (ian@quixote)

	* bltin.c (tic, toc): New functions.

	* scan.l, rlab.y: Trying to get error handling right so that the
	extra newline isn't needed.

Fri Nov 20 19:21:05 1992  Ian Searle  (ian@quixote)

	* fi_1.c (matrix_Norm): Fix 2-norm mistake.

	* bltin.c (Inf): New function.

Thu Nov 19 20:11:32 1992  Ian Searle  (ian@quixote)

	* scan.l (new_file): Fixed lineno bug, wasn't setting correct
	value in lnstack[].

	* config.h: Added choices for CONST, and BIG_ENDIAN,
	LITTLE_ENDIAN. 

	* bltin.c (Nan): New function.

Wed Nov 18 20:51:26 1992  Ian Searle  (ian@quixote)

	* config.h: Added option to use errno checking, or matherr().

	* bltin.c (matherr): New function.

Mon Nov 16 19:11:54 1992  Ian Searle  (ian@quixote)

	* bltin.c, main.c, scalar.c, matrix.c: Changed format() operation.
	Now format() works on REAL and COMPLEX.

	* main.c (init_misc): popen() FILE *paged_output, for paged matrix
	output. 

	* main.c: Removed inc_jmp_buff... and dec_jmp.... Replaced with
	jmp1, jmp2. Two simple variables should do the job.

	* scan.l (new_file): bptr = 0, if arg = 0.

Sun Nov 15 12:08:42 1992  Ian Searle  (ian@quixote)

	* matrix_*.c, bltin.c: Add calls to matrix_screen_string().

	* matrix.h (matrix_screen_string): Check for MTYPE == STRING, if
	TRUE, issue warning and longjmp().

Sat Nov 14 14:05:58 1992  Ian Searle  (ian@quixote)

	* sscan.l (new_file): Another overhaul, maybe someday I'll get it
	right.

	* rlab.y: Removed YYERROR usage, and replaced with longjmp().

Fri Nov 13 20:54:28 1992  Ian Searle  (ian@quixote)

	* main.c: Make jmp_buff an array. Change setjmp() call when
	loopong through filename arguments. If we run out of jmp_buff[]
	array, then STOP program.

Wed Nov 11 23:11:30 1992  Ian Searle  (ian@quixote)

	* matrix_op1.c (matrix_MultiplyCC): Call BLAS-3 ZGEMM().

Tue Nov 10 19:06:47 1992  Ian Searle  (ian@quixote)

	* matrix.c (matrix_CreateCLoad): Fixed bad matrix ref.

	* matrix.c (matrix_read_string): Completed.

Mon Nov  9 20:00:24 1992  Ian Searle  (ian@quixote)

	* !!! ADDITIONS TO LAPACK-C LIBRARY !!!

	* matrix_op2.c (matrix_Ldivide): Checks appropriate dimensions and
	calls matrix_LS.

	* fi_2.c (matrix_LS): New functions.

	* fi_1.c, fi_2.c: New files.

	* fi.c (matrix_Norm): The 2-norm is the ration of 1st/last
	singular values.

Sun Nov  8 10:39:10 1992  Ian Searle  (ian@quixote)

	* op_matrix.c (matrix_*_assign): Add call to matrix_gt_zero() to
	check indices for validity.

	* matrix_op2.c (matrix_gt_zero): New function

	* op_matrix.c (matrix_*_assign): Create LHS after looking at RHS
	type. 

	* op_append.c (matrix_string_app): Fix indexing bug that went
	passed end of array.

	* random.c (SRand): Add "clock" arg to enable setting seed from
	the clock.

Mon Nov  2 18:54:49 1992  Ian Searle  (ian@quixote)

	* matrix_op1.c (Sqrt, Log,...): Check for argument elements less
	than 0.

	* scalar_op1.c, matrix_op1.c (Log10): Added complex log10()
	capability. 

	* op_matrix.c (matrix_sub): Fix reduction of matrix string to
	scalar string.

	* matrix.c (matrix_print_string): Check for NULL ptrs before using
	strlen(). 

	* matrix.c (matrix_CreateS): Init string ptrs to 0 (for now).

	* util.c (print_What): Set unused matrix string ptrs to NULL
	string. 

Sun Nov  1 15:54:36 1992  Ian Searle  (ian@quixote)

	* matrix.[ch], op_append.c, op_matrix.c: Started in on adding
	matrices that contain STRING elements.

Sat Oct 31 11:34:13 1992  Ian Searle  (ian@quixote)

	* code.c, (ret_from_function): Do not try and clean argument
	variables while popping them off the stack.

	* bltin.c, (Name): Force name() to return "CONSTANT" when the
	entity name is "-1" (an constant in an argument list").

	* math_1.c, fi.c: Improved arg error checking, and added 2-norm
	option to Norm.

Fri Oct 30 17:43:39 1992  Ian Searle  (ian@quixote)

	* op_matrix.c: (matrix_vector_sub): Allow indexing of a SCALAR
	(only a single index).

	* op.c, util.c: Make all operations return a SCALAR, if the result
	is a 1x1 MATRIX.

	* scan.l: Call signal (SIG_IGN) in yy_input() to avoid causing a
	flex error.

Thu Oct 29 19:58:05 1992  Ian Searle  (ian@quixote)

	* rlab.y, scan.l: Add prompt variable to change the prompt for IF,
	FOR, WHILE, and functions.

	* code.c (assign): Finished fixing garbage collection details. In
	this case I was copying SCALARS twice. Now v0.30 is as good as
	0.21. 

Wed Oct 28 21:50:42 1992  Ian Searle  (ian@quixote)

	* op_matrix.c (matrix_assign) Clean rhs value.

	* util.c (convert_to_matrix): Clean original SCALAR.

	* op_append.c (vector_create): Add garbage-collection.

	* scan.l (new_file): Simplified scheme for input stream switching.

Mon Oct 26 19:51:37 1992  Ian Searle  (ian@quixote)

	* matrix.c (matrix_ExtractVector): Made more MATLAB like, by
	looking at type of parent matrix when deciding what dimensions of
	extracted vector should be.

	* relation.c: All functions, made SCALAR rel-op MATRIX and
	vice-versa work.

	* main.c (intcatch): New function, catch user interrupts.

Sat Oct 24 08:29:22 1992  Ian Searle  (ian@quixote)

	* scan.l: Added trailing context rules for: 3./A conditions.

	* code.c (load_local_var): Make local vars UNDEFINED.

Fri Oct 23 18:08:03 1992  Ian Searle  (ian@quixote)

	* Started Adding el-ops to rlab.y, code.c...

	* Finished eradicating VECTORS

Tue Oct 20 23:47:39 1992  Ian Searle  (ian@quixote)

	* Embarking on experiment... remove VECTORS from the language as a
	separate data type. Replace ';' with ',' as arg separators.

Thu Oct 15 18:31:51 1992  Ian Searle  (ian@quixote)

	* code.c (find_lineno, find_filename): Remove function arg.

Wed Oct 14 19:34:10 1992  Ian Searle  (ian@quixote)

	* rlab.y, code.c: Add loff (100) to line numbers to avoid op-code
	collisions when searching backwards through the codes.

Mon Oct 12 20:35:55 1992  Ian Searle  (ian@quixote)

	* code.c (function_define): Fixe 1st line number assign to test
	for line #0.

Fri Oct  9 23:38:58 1992  Ian Searle  (ian@quixote)

	* bltin.c (Clear): New function.

	* Reverted back to UNDEFINED variables.

Thu Oct  8 19:28:47 1992  Ian Searle  (ian@quixote)

	* code.c (list_create): Make list creation use numerical index
	values. 

	* trig.c, vector_op2.[ch], matrix_op2.[ch]: Make atan2() take
	vectors and matrices as args.

	* function.c (function_Destroy): Check list existence before
	destroy. 

Wed Oct  7 18:59:12 1992  Ian Searle  (ian@quixote)

	* Start incorporating some of the simpler, more common op-code
	functions directly into the switch.

	* rlab.[yh], code.[ch], scan.l: Have finished most of the changes
	mention below. Additionally have made y = function()... workable.

Mon Oct  5 00:58:30 1992  Ian Searle  (ian@quixote)

	* rlab.[yh], code.[ch], function.[ch]: Extensive changes to allow
	copying a user-function. Some of the changes: 1) adding two new
	op-codes, OP_PUSH_ARG, OP_PUSH_LOCAL, which push local and arg
	vars without explicit ptr reference 2) the new op-codes caused
	changes to function_call(), function_ret(), ret_from_function(),
	push_var, bltin(), and some others. The new op-codes also caused
	some changes in the parser actions.

Sat Oct  3 20:28:15 1992  Ian Searle  (ian@quixote)

	* function.[ch], code.c: Allow user-functions to be assigned,
	copied. 

	* scalar.c, vector.c, matrix.c: *_Print() functions changed to
	print COMPLEX prettier.

Wed Sep 30 07:16:43 1992  Ian Searle  (ian@quixote)

	* rlab.y, scan.l: Parser is re-enbtrant now. (%pure_parser)

Mon Sep 28 19:27:29 1992  Ian Searle  (ian@quixote)

	* vector.c (vector_copy_complex): Fixed stupid indexing bugs.

	* math_3.c (FFT): Don't use rfftf() anymore, scale the result by
	1/N.

	* op.c, vector_op1.c, matrix_op2.c (power related functions):
	Added scalar^matrix, matrix^scalar, vector^vector.

	* vector.c, matrix.c (Create functions): Removed ASSERT(), and
	replaced with if-test for dimensions < 0.

	* random.c (Rand): Fix improper ref to arg.u.val, should be
	arg.u.ent. 

Sun Sep 27 20:44:54 1992  Ian Searle  (ian@quixote)

	* op_matrix.c (matrix_transpose): Allow transpose of a vector.

	* matrix_op1.c (matrix_Transpose): Make complex transpose,
	complex-conjugate transpose.

	* random.c (SRand): error() when srand() os called with zero
	valued arg.

	* matrix_comp.c (matrix_Eig_NEP): Malloc for vl now, even though
	we don't uses it.

	* scan.l: Made 1e6i work.

	* random.c (Srand): Fixed bozo mistakes in inner switch.

	* matrix_op1.c (matrix_Log10): Fixed assignment.

	* rlab.y, code.[ch]: Modified list creation syntax, and behavior.

Thu Sep 24 21:52:01 1992  Ian Searle  (ian@quixote)

	* code.c (list_create): Write variable names to objects, as well
	as ListNodes.

	* scalar.c, vector.c, matrix.c string.c btree.c (Write): Fixed
	write functions so that the default name is NOT written on the
	entity. 

	* math_1.c (Exp): Fixed exp() to take complex constant.

Wed Sep 23 19:08:13 1992  Ian Searle  (ian@quixote)

	* matrix.c (matrix_Print): Played with print format.

	* matrix_comp.c (NEP): Finally added calls to ZGEEV.

	* math_2.c (Max, Min): Fixed stupid bug in returning max and min
	values of a scalar.

	* config.rs6000: New header file.

	* math_3.c (IFFT): New function.

Tue Sep 22 23:08:14 1992  Ian Searle  (ian@quixote)

	* op.c: Added tests for STRINGS in +, -, *, / functions, must
	finish rest.

	* util.c (convert_to_scalar): Added more error checking.

	* scan.l: Start counting interactive lines at 0.

	* main.c (error_?): Break error message into multiplt lines.

	* vector.[ch] (vector_Extend): Removed type spec. Reduce scope of
	function, now it only does what the name implies, extend the
	vector if necc.

	* op_vector.c (vector_assign): Many changes, mostly centered
	aaround calling vector_Extend.

Mon Sep 21 19:34:23 1992  Ian Searle  (ian@quixote)

	* scan.l: Added rule to scanner to handle `1e-3'. No decimal
	point. 

	* Doc/rlab.tex: Finally started working on the doc again.

	* rlab.y (yyparse): Removed silly restrictions in for, if, while,
	and function statements forcing users to type `{' on the same line
	as the `)'.

	* config.h: Added FOPEN_MAX for users who don't have one to set.

	* math_3.c (FFT): Added vector and matrix fft capability. This is
	neither finished, or checked out. Will undoubtedly change.

Sun Sep 20 19:01:13 1992  Ian Searle  (ian@quixote)

	* random.c (Rand): New file, some new functions. Finished hooking
	up rand ro RANLIB functions.

	* rlab.y (yyparse): Added ':' to precedence table (just above
	','), and changed vec_expr production from:

         | vec_expr ',' expr  { code(OP_VEC_APPEND); }

	 to:

         | vec_expr ',' vec_expr  { code(OP_VEC_APPEND); }

	 This change makes expressions like `1,2,3:10' possible.


	* op_matrix.c (ent_ent_mat_promote): same as previous.

	* op_matrix.c (ent_con_mat_promote): same as previous.

	* op_matrix.c (con_ent_mat_promote): Fixed silly type checking
	errors that were preventing b[1;1,2] from working.

Sat Sep 19 00:00:39 1992  Ian Searle  (ian@quixote)

	* Picked up changes in config.sun4, bltin.h, btree.c, courtesy 
	R. M. Cothren.

	* op_vector.c (vector_assign): Improved error handling, and added
	more remove_tmp_destroy() calls.

Fri Sep 18 19:18:24 1992  Ian Searle  (ian@quixote)

	* op_vector.c  (vector_matrix_app): Same fix as below.

	* op_vector.c (vector_vector_app): Type in loop index (for REAL,
	COMPLEX) causing core dump. fix: add `+1'

	* code.c (bltin): Try and clean-up the argument from the tmplist.

	* code.c (ret_from_function): call remove_tmp_destroy() when
	poping local and arg vars.

	* op_matrix.c (matrix_assign): Add calls to remove_tmp_destroy(). 

	* op_matrix.c (matrix_transpose): Add call to
	remove_tmp_destroy().

Thu Sep 17 21:28:23 1992  Ian Searle  (ian@quixote)

	* math_3.c (FFT): Not finished yet, but compiled and setup
	libCfftpack.a 

	* math_1.c (SRand): New function.

	* math_1.c (Rand): Converted to RANLIB usage.

	* print.f (do_printf): Fixed sval overflow bug. Put in a test, and
	an error message.

Tue Sep 15 22:31:16 1992  Ian Searle  (ian@quixote)

	* code.c (list_member): Added more error checking, and .class
	capability for user and bltin functions.

	* matrix_comp.c (matrix_Eig_GSEP): New function.

Mon Aug 10 00:05:41 1992  Ian Searle  (ian@quixote)

	* print.c (Printf): New Function.

Thu Aug  6 18:53:35 1992  Ian Searle  (ian@quixote)

	* matrix_comp.c (Qr): Add COMPLEX qr() matrix_QrZ().

	* matrix_comp.c (Qr): Add install() calls.

	* math_1.c (Solve): Allow vector, or column matrix as 2nd arg.

	* rlab.y (yyparse): Add error checking for break and continue
	outsid of loops.

	* bltin.c (Zero): if zero() called with no arg of 0 return a
	scalar. 

Wed Aug  5 20:50:50 1992  Ian Searle  (ian@quixote)

	* Added ./lib/editline; a readline(3) like library, but smaller.

Tue Aug  4 21:36:39 1992  Ian Searle  (ian@quixote)

	* code.c (function_return): Set the name of an object to 0 when we
	zero out the name of the entity, returning local datums only.

	* bltin.c (Size): Make size() return 1 for size of a scalar.

	* code.c, functi[ch]: Added capability to print() to print
	function op-codes when -d is used.

	* Finished up most of relational ops (matrix-scalar).

Sun Aug  2 11:09:21 1992  Ian Searle  (ian@quixote)

	* relation.c, complex.[ch], scalar_op1.[ch], vector_op1.[ch]:
	working on finishing up the vector - scalar realtional ops.

	* code.c (find_lineno): (*--p) prevented checking current lineno. 

Fri Jul 31 20:39:38 1992  Ian Searle  (ian@quixote)

	* code.[ch], rlab.y, dissassem.c, main.c: Added file name, and
	line numbers to error messages. Some new functions...
	find_lineno(), find_file_name().

Tue Jul 28 23:38:03 1992  Ian Searle  (ian@quixote)

	* Have added the basics of complex variables, constants, etc...
	Have re-checked everything in after extensive changes to many
	files, and some brand-new files.

